Subject: Re: [RFC] mac80211: clean up frame receive handling

From: Jouni Malinen <[email-masked]>
Date: Mon, 17 Dec 2007 20:22:53 -0800

On Fri, Dec 14, 2007 at 01:14:03PM +0100, Johannes Berg wrote:

> I think in theory all eapol frames are sent to the PAE group address,
> but I have no idea which of the checks would be more efficient. It seems
> that the first could be optimised a lot because it's constant too...

They are not.. PAE group address is used for all EAPOL frames in
non-shared media LANs (e.g., wired Ethernet switch), but IEEE 802.11
uses the specific MAC address of the PAE since it is a shared media LAN
(i.e., the frames are between the unicast MAC address of the non-AP
STA/Supplicant and AP/Authenticator). If we end up having to drop the
PAE group addressed EAPOL frames in mac80211 anyway due to Linux
bridging code not doing this, we could combine these two validations and
just accept the unicast MAC address of the device itself as a valid
destination address for received EAPOL frames (and as the only valid
source address for transmitted ones).

-- 
Jouni Malinen                                            PGP id EFC895FA